from FXCMRestWarpper import param
from FXCMRestWarpper.requsest_decor import req
from FXCMRestWarpper import setting
from FXCMRestWarpper.auth import authentication
from socketIO_client.exceptions import SocketIOError
import json
import time

class stream:
    update_time = None
    def __init__(self,auth):
        self.auth = auth

    def subscribe(self,pairs):
        params = param.StreamParam().getSubscribeParam()
        params['pairs'] = pairs
        post = req.PostRequset(self.auth)
        rep = post.request(setting.TRADING, "/subscribe", params)
        print(rep)
        return rep

    def on_price_update(self,msg):
        md = json.loads(msg)
        self.update_time = md["Updated"]
        print(md)

    def on_connect(self):
        print('connect')
    def on_disconnect(self):
        print(self.update_time)
        print('disconnect')
    def on_reconnect(self):
        print(self.update_time)
        print('reconnect')

if __name__ == '__main__':
    test = authentication.Authentication()
    stream = stream(test)
    stream.subscribe('USD/JPY')
    stream.subscribe('EUR/USD')
    stream.subscribe('GBP/USD')
    stream.subscribe('EUR/JPY')
    stream.subscribe('AUD/USD')
    print(test.socketIO.connected)
    # the method of listening is still under construction
    test.socketIO.on('connect', stream.on_connect)
    test.socketIO.on('disconnect', stream.on_disconnect)
    test.socketIO.on('reconnect', stream.on_reconnect)
    test.socketIO.on('USD/JPY', stream.on_price_update)
    test.socketIO.on('EUR/USD', stream.on_price_update)
    test.socketIO.on('GBP/USD', stream.on_price_update)
    test.socketIO.on('EUR/JPY', stream.on_price_update)
    test.socketIO.on('AUD/USD', stream.on_price_update)
    print(test.socketIO.connected)
    print(test.socketIO)
    try:
        test.socketIO.wait()
    except SocketIOError:
        print(SocketIOError)
