from FXCMRestWarpper.auth import authentication
from FXCMRestWarpper.tables import snapshot
from FXCMRestWarpper.orders import trade
from FXCMRestWarpper.auth import account
from FXCMRestWarpper.data import stream
from socketIO_client.exceptions import SocketIOError

"""
this is an example on how to use the warpper
"""

if __name__ == '__main__':
    # first create an auth object
    auth = authentication.Authentication()
    # try to get a snapshot of everything and print it out
    snap = snapshot.snapshot(auth)
    mylist = ['Offer', 'OpenPosition', 'ClosedPosition', 'Order',
              'Summary', 'LeverageProfile', 'Account', 'Properties']
    print(snap.getsnapshot(mylist))
    # get account number before open a trade
    account = account.Account(auth)
    accounts = account.get_account_number()
    # try to open a trade
    trade = trade.Trade(auth)
    print(trade.openTrade(account_id=accounts[0],
                          symbol='EUR/USD',
                          is_buy=1,
                          rate=1.7810,
                          amount=1))  # there are more parameter but i already set a default values for them
    # try to listen to tick data
    stream = stream.stream(auth)
    stream.subscribe('USD/JPY')
    auth.socketIO.on('USD/JPY', stream.on_price_update)
    auth.socketIO.on('connect', stream.on_connect)
    auth.socketIO.on('disconnect', stream.on_disconnect)
    auth.socketIO.on('reconnect', stream.on_reconnect)
    try:
        auth.socketIO.wait()
    except SocketIOError:
        print(SocketIOError)
