import pandas as pd

#from trading_ig.lightstreamer import Subscription
from FXCMRestWarpper.auth import authentication
from FXCMRestWarpper.data import stream
from ..price_parser import PriceParser
from ..event import TickEvent
from .base import AbstractTickPriceHandler
import json
import datetime
from threading import Thread


class FXCMTickPriceHandler(AbstractTickPriceHandler):
    def __init__(self, events_queue, tickers):
        self.price_event = None
        self.events_queue = events_queue
        self.continue_backtest = True
        #self.fxcm_socket = fxcm_socket
        self.tickers_lst = tickers
        self.tickers = {}
        self.socket = authentication.Authentication()
        for ticker in self.tickers_lst:
            self.tickers[ticker] = {}

        # Login and get socket
        self.socket.login()
        # Adding the "on_price_update" function to Subscription
        data = stream.stream()
        data.subscribe('EUR/USD',self.socket.getToken(),self.socket.getSocketid())
        # Registering the Subscription
        self.socket.socketIO.on('EUR/USD',self.on_prices_update)
        #socket.socketIO.wait()

        #self.receive_events_thread = Thread(target=self._receive_events_thread(socket.socketIO))
        #self.receive_events_thread.daemon = True
        #self.receive_events_thread.start()


    def on_prices_update(self, msg):
        print(msg)
        tev = self._create_event(json.loads(msg))
        if self.price_event is not None:
            print("losing %s" % self.price_event)
        self.price_event = tev

    def _create_event(self, data):
        ticker = data["Symbol"]
        index = pd.to_datetime(datetime.datetime.fromtimestamp(float(data["Updated"])))
        bid = PriceParser.parse(data["Rates"][0])
        ask = PriceParser.parse(data["Rates"][1])
        return TickEvent(ticker, index, bid, ask)

    def stream_next(self):
        """
        Place the next PriceEvent (BarEvent or TickEvent) onto the event queue.
        """
        if self.price_event is not None:
            self._store_event(self.price_event)
            self.events_queue.put(self.price_event)
            self.price_event = None

    def _receive_events_thread(self,socketIO):
        socketIO.wait(1)


